Package org.apache.tapestry5.ioc.internal

## Class AbstractServiceInstrumenter

- java.lang.Object
- - org.apache.tapestry5.ioc.internal.AbstractServiceInstrumenter

- Direct Known Subclasses:
    `AdvisorDefImpl`, `DecoratorDefImpl`

      public class AbstractServiceInstrumenter
      extends Object

  Abstract base class for implementations of `ServiceDecorator` (i.e., old school) and `ServiceAdvisor` (i.e., new school). "Instrumenter" is a rought approximation of what these two approaches have in common: instrumenting of method calls of a service.
  Since:
    5.1.0.0

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected String[]` | `constraints` |
    `protected IdMatcher` | `idMatcher` |
    `protected Method` | `method` |
    `protected PlasticProxyFactory` | `proxyFactory` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractServiceInstrumenter​(Method method, String[] patterns, String[] constraints, Class serviceInterface, Set<Class> markers, PlasticProxyFactory proxyFactory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String[]` | `getConstraints()` |
    `Set<Class>` | `getMarkers()` |
    `Class` | `getServiceInterface()` |
    `boolean` | `matches​(ServiceDef serviceDef)` | Returns true if any provided pattern matches the id of the service.
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### method

          protected final Method method

    - #### idMatcher

          protected final IdMatcher idMatcher

    - #### constraints

          protected final String[] constraints

    - #### proxyFactory

          protected final PlasticProxyFactory proxyFactory

  - ### Constructor Detail

    - #### AbstractServiceInstrumenter

          public AbstractServiceInstrumenter​(Method method,
                                             String[] patterns,
                                             String[] constraints,
                                             Class serviceInterface,
                                             Set<Class> markers,
                                             PlasticProxyFactory proxyFactory)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getConstraints

          public String[] getConstraints()

    - #### matches

          public boolean matches​(ServiceDef serviceDef)

      Returns true if any provided pattern matches the id of the service.

    - #### getMarkers

          public Set<Class> getMarkers()

    - #### getServiceInterface

          public Class getServiceInterface()